require(ggplot2)
require(grid)


VBsnov_psi = function (beta,k0,log_sigma_v,v,log_sigma_u,u,t0,plpo,psi.vb = 1,maxage=10) {
age = seq(1,maxage,1)
Length_age = rep(0,length(age))
gamma = exp(beta*10 + exp(log_sigma_v)*v)
k = exp(k0) * exp( exp(log_sigma_u)*u )
Linf = gamma 

for (ii in 1:length(age)) {

Length_age[ii] <- Linf*(k^(psi.vb-1))*(1-exp(-k*(age[ii]-t0)))

}
if (plpo==0) {
plot(Length_age ~ age, xlim = c(0,max(age)),ylim = c(0,max(Length_age)),pch=16)
}

else if (plpo==1) {
points(Length_age ~ age,pch=15)
}

return(data.frame(Age=age,Length=Length_age))
}



#seed 71, you need the file results.par.Linf.c.k.c.vol71
#results.par = readRDS("results.par.volcoh.psi.1.seed.69")


results.par = results.par.volcoh.psi.1.seed.69

psi.vb = 1

# In RStudio I plot with Width = 950, Height = 800


seed = 69

set.seed(seed)

data.df = subset(allstreams.vol.df, Cohort!="C13", drop = T)
data.df = data.frame(lapply(data.df, function(x) if (is.factor(x)){ factor(x)} else {x}))

data.df$Cohort = factor(data.df$Cohort)

marktable <- with(data.df,table(Mark)) 

samplemark <- (sample(marktable[marktable>=4],15)) #total number is 62 for fish sampled more than 3 t

exclmar <- as.numeric(rownames(samplemark))
 
markd <- subset(data.df,Mark %in% exclmar)

obsmiss <- data.frame(Mark=rep(0,10*length(exclmar)),Age = rep(0,10*length(exclmar)) ,
 Obs = rep(0,10*length(exclmar)),Cohort = rep(0,10*length(exclmar)))

missrow <- matrix(0,10*length(exclmar),1)


vectincl = c(1)

nrowdp <- rep(0,length(exclmar))
for (i in 1:length(exclmar)) {

dataprov <- 0
dataprov <- subset(markd,Mark == exclmar[i])
vectexcl <- seq(1,nrow(dataprov),1)[-vectincl]
contlen <- length(missrow[missrow>0])
nrowdp[i] <- nrow(dataprov)-length(vectincl)
missrow[(contlen+1):(contlen + nrowdp[i])] <- which(data.df[,"Mark"] == exclmar[i])[vectexcl]

obsmiss[(contlen+1):(contlen + nrowdp[i]),"Mark"] <- dataprov$Mark[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Age"] <- dataprov$Age[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Obs"] <- dataprov$Length[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Cohort"] = dataprov$Cohort[vectexcl]
}
obsmiss <- obsmiss[obsmiss$Mark>0,]
missrow <- missrow[missrow>0]

#print(missrow)
allstreams.miss.df <- data.df[-c(missrow),]



markuv <- data.frame(Mark = unique(allstreams.miss.df$Mark), 
u = results.par$u,v = results.par$v)


valid <- rep(0,500)

for (i in 1:length(exclmar)) {

#print(i)

#print(exclmar[i])

cohort_mark <<- data.df[data.df$Mark == exclmar[i],"Cohort"]

cohort_mark <<- as.numeric(cohort_mark[1])

#print(cohort_mark)

if (cohort_mark ==1) {

Linf <- results.par$beta[1] 
k <- results.par$beta_k0[1]
} else {

Linf <- results.par$beta[1] + results.par$beta[cohort_mark] 
k <- results.par$beta_k0[1] + results.par$beta_k0[cohort_mark] 
}

plot.vb <- VBsnov_psi(Linf,k,results.par$log_sigma_v,markuv[markuv$Mark==exclmar[i],"v"],results.par$log_sigma_u,
markuv[markuv$Mark==exclmar[i],"u"],results.par$beta_t0,
plpo = 2, psi.vb = psi_fixed,maxage=15)

contlen <- length(valid[valid>0])

nrowmiss <- nrow(subset(obsmiss,Mark==exclmar[i]))

#print(plot.vb[plot.vb$Age %in% obsmiss[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] )
#print(valid[(contlen+1):(contlen+nrowmiss)])

valid[(contlen+1):(contlen+nrowmiss)] <- 
plot.vb[plot.vb$Age %in% obsmiss[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] 

}

valid <- valid[valid>0]
#print(valid)

obsmiss$Pred <- valid


SSE.pred <- sum((obsmiss$Obs-obsmiss$Pred)^2)
SST.pred <- sum((obsmiss$Obs-mean(obsmiss$Obs))^2)
Rsq.pred <- 1-(SSE.pred/SST.pred)

mean.err.pred <- sqrt(mean((obsmiss$Obs-obsmiss$Pred)^2))


for (i in 1:nrow(obsmiss)) {
obsmiss$length.avg[i] = with(subset(data.df,Age==obsmiss$Age[i] & 
Cohort == levels(data.df$Cohort)[obsmiss$Cohort[i]]),mean(Length))
}




SSE.avg <- sum((obsmiss$Obs-obsmiss$length.avg)^2)
SST.avg <- sum((obsmiss$Obs-mean(obsmiss$Obs))^2)
Rsq.avg <- 1-(SSE.avg/SST.avg)

mean.err.avg <- sqrt(mean((obsmiss$Obs-obsmiss$length.avg)^2))


size.label.x = 13
size.text.x = 8
line.lwd = 0.6
size.label.y = 13
size.text.y = 8
size.legend.text = 13
size.legend.title = 13
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3
col.line = "gray20"
col.points = "gray20"


lb = paste("psi == ",1)

gvol <- ggplot(subset(obsmiss), aes(x = Pred, y = Obs)) 	  
gvolpsi.1.modpred  <- gvol + geom_point(pch = 16, size = size.point, col = col.points) +
coord_fixed() +
geom_abline(intercept=0, slope=1, linetype = 2, lwd=1.2) +
 #      ggtitle("Gatsnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  scale_x_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  labs(y = "Observed length (mm)") +
           labs(x = "Predicted length (mm)") +
            #annotate("text", x = 150, y = 400, label = "c")
             annotate("text", x = 260, y = 200, 
          # label = "~psi~=~0.3",parse = T)
          label = lb,parse = TRUE) +
          annotate("text", x = 150, y = 300, label = "a", size = 6)
   
           

#arrange_ggplot2(gvolpsi.1..modpred,gvolpsi.1.avgpred,ncol = 2)

require(ggplot2)
require(grid)



 
#seed 42, you need the file results.par.Linf.c.k.c.gat42
results.par = results.par.volcoh.psi.0.5.seed.69

psi.vb = 0.5

# In RStudio I plot with Width = 1000, Height = 500

seed = 69

set.seed(seed)


data.df = subset(allstreams.vol.df, Cohort!="C13", drop = T)
data.df = data.frame(lapply(data.df, function(x) if (is.factor(x)){ factor(x)} else {x}))

marktable <- with(data.df,table(Mark)) 

samplemark <- (sample(marktable[marktable>=4],15)) #total number is 62 for fish sampled more than 3 t

exclmar <- as.numeric(rownames(samplemark))
 
markd <- subset(data.df,Mark %in% exclmar)

obsmiss <- data.frame(Mark=rep(0,10*length(exclmar)),Age = rep(0,10*length(exclmar)) ,
 Obs = rep(0,10*length(exclmar)),Cohort = rep(0,10*length(exclmar)))

missrow <- matrix(0,10*length(exclmar),1)


vectincl = c(1)

nrowdp <- rep(0,length(exclmar))
for (i in 1:length(exclmar)) {

dataprov <- 0
dataprov <- subset(markd,Mark == exclmar[i])
vectexcl <- seq(1,nrow(dataprov),1)[-vectincl]
contlen <- length(missrow[missrow>0])
nrowdp[i] <- nrow(dataprov)-length(vectincl)
missrow[(contlen+1):(contlen + nrowdp[i])] <- which(data.df[,"Mark"] == exclmar[i])[vectexcl]

obsmiss[(contlen+1):(contlen + nrowdp[i]),"Mark"] <- dataprov$Mark[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Age"] <- dataprov$Age[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Obs"] <- dataprov$Length[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Cohort"] = dataprov$Cohort[vectexcl]
}
obsmiss <- obsmiss[obsmiss$Mark>0,]
missrow <- missrow[missrow>0]

#print(missrow)
allstreams.miss.df <- data.df[-c(missrow),]



markuv <- data.frame(Mark = unique(allstreams.miss.df$Mark), 
u = results.par$u,v = results.par$v)


valid <- rep(0,500)

for (i in 1:length(exclmar)) {

#print(i)

#print(exclmar[i])

cohort_mark <<- data.df[data.df$Mark == exclmar[i],"Cohort"]

cohort_mark <<- as.numeric(cohort_mark[1])

#print(cohort_mark)

if (cohort_mark ==1) {

Linf <- results.par$beta[1] 
k <- results.par$beta_k0[1]
} else {

Linf <- results.par$beta[1] + results.par$beta[cohort_mark] 
k <- results.par$beta_k0[1] + results.par$beta_k0[cohort_mark] 
}

plot.vb <- VBsnov_psi(Linf,k,results.par$log_sigma_v,markuv[markuv$Mark==exclmar[i],"v"],results.par$log_sigma_u,
markuv[markuv$Mark==exclmar[i],"u"],results.par$beta_t0,
plpo = 2, psi.vb = psi.vb,maxage=15)

contlen <- length(valid[valid>0])

nrowmiss <- nrow(subset(obsmiss,Mark==exclmar[i]))

#print(plot.vb[plot.vb$Age %in% obsmiss[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] )
#print(valid[(contlen+1):(contlen+nrowmiss)])

valid[(contlen+1):(contlen+nrowmiss)] <- 
plot.vb[plot.vb$Age %in% obsmiss[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] 

}

valid <- valid[valid>0]
#print(valid)

obsmiss$Pred <- valid


SSE.pred <- sum((obsmiss$Obs-obsmiss$Pred)^2)
SST.pred <- sum((obsmiss$Obs-mean(obsmiss$Obs))^2)
Rsq.pred <- 1-(SSE.pred/SST.pred)

mean.err.pred <- sqrt(mean((obsmiss$Obs-obsmiss$Pred)^2))


for (i in 1:nrow(obsmiss)) {
obsmiss$length.avg[i] = with(subset(data.df,Age==obsmiss$Age[i] & 
Cohort == levels(data.df$Cohort)[obsmiss$Cohort[i]]),mean(Length))
}




SSE.avg <- sum((obsmiss$Obs-obsmiss$length.avg)^2)
SST.avg <- sum((obsmiss$Obs-mean(obsmiss$Obs))^2)
Rsq.avg <- 1-(SSE.avg/SST.avg)

mean.err.avg <- sqrt(mean((obsmiss$Obs-obsmiss$length.avg)^2))
options(digits=2)

#size.label.x = 25
#size.text.x = 20
#size.point = 5
#size.label.y = 25
#size.text.y = 20
#size.legend.text = 15
#size.legend.title = 15
#unit.legend.h = 1.4
#unit.legend.w = 1.4


lb = paste("psi == ",0.5)

gvolpsi <- ggplot(subset(obsmiss), aes(x = Pred, y = Obs)) 	  
gvolpsi.0.5.modpred  <- gvolpsi + geom_point(pch = 16, size = size.point, col = col.points) +
coord_fixed() +
geom_abline(intercept=0, slope=1, linetype = 2, lwd=1.2) +
 #      ggtitle("mediantimesnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,-9), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  scale_x_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  labs(y = "Observed length (mm)") +
           labs(x = "Predicted length (mm)") +
           #annotate("text", x = 150, y = 400, label = "a") +
           annotate("text", x = 260, y = 200, 
          # label = "~psi~=~0.3",parse = T)
          label = lb,parse = TRUE) +
          annotate("text", x = 150, y = 300, label = "b", size = 6)
       
       #expression(paste(psi," = 0.3"
           
   
           
#arrange_ggplot2(gvolpsi.modpred,gvolpsi.avgpred,ncol = 2)


results.par = results.par.volcoh.psi.0.seed.69

psi.vb = 0

# In RStudio I plot with Width = 1000, Height = 500

seed = 69

set.seed(seed)


data.df = subset(allstreams.vol.df, Cohort!="C13", drop = T)
data.df = data.frame(lapply(data.df, function(x) if (is.factor(x)){ factor(x)} else {x}))

marktable <- with(data.df,table(Mark)) 

samplemark <- (sample(marktable[marktable>=4],15)) #total number is 62 for fish sampled more than 3 t

exclmar <- as.numeric(rownames(samplemark))
 
markd <- subset(data.df,Mark %in% exclmar)

obsmiss <- data.frame(Mark=rep(0,10*length(exclmar)),Age = rep(0,10*length(exclmar)) ,
 Obs = rep(0,10*length(exclmar)),Cohort = rep(0,10*length(exclmar)))

missrow <- matrix(0,10*length(exclmar),1)


vectincl = c(1)

nrowdp <- rep(0,length(exclmar))
for (i in 1:length(exclmar)) {

dataprov <- 0
dataprov <- subset(markd,Mark == exclmar[i])
vectexcl <- seq(1,nrow(dataprov),1)[-vectincl]
contlen <- length(missrow[missrow>0])
nrowdp[i] <- nrow(dataprov)-length(vectincl)
missrow[(contlen+1):(contlen + nrowdp[i])] <- which(data.df[,"Mark"] == exclmar[i])[vectexcl]

obsmiss[(contlen+1):(contlen + nrowdp[i]),"Mark"] <- dataprov$Mark[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Age"] <- dataprov$Age[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Obs"] <- dataprov$Length[vectexcl]
obsmiss[(contlen+1):(contlen + nrowdp[i]),"Cohort"] = dataprov$Cohort[vectexcl]
}
obsmiss <- obsmiss[obsmiss$Mark>0,]
missrow <- missrow[missrow>0]

#print(missrow)
allstreams.miss.df <- data.df[-c(missrow),]



markuv <- data.frame(Mark = unique(allstreams.miss.df$Mark), 
u = results.par$u,v = results.par$v)


valid <- rep(0,500)

for (i in 1:length(exclmar)) {

#print(i)

#print(exclmar[i])

cohort_mark <<- data.df[data.df$Mark == exclmar[i],"Cohort"]

cohort_mark <<- as.numeric(cohort_mark[1])

#print(cohort_mark)

if (cohort_mark ==1) {

Linf <- results.par$beta[1] 
k <- results.par$beta_k0[1]
} else {

Linf <- results.par$beta[1] + results.par$beta[cohort_mark] 
k <- results.par$beta_k0[1] + results.par$beta_k0[cohort_mark] 
}

plot.vb <- VBsnov_psi(Linf,k,results.par$log_sigma_v,markuv[markuv$Mark==exclmar[i],"v"],results.par$log_sigma_u,
markuv[markuv$Mark==exclmar[i],"u"],results.par$beta_t0,
plpo = 2, psi.vb = psi.vb,maxage=15)

contlen <- length(valid[valid>0])

nrowmiss <- nrow(subset(obsmiss,Mark==exclmar[i]))

#print(plot.vb[plot.vb$Age %in% obsmiss[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] )
#print(valid[(contlen+1):(contlen+nrowmiss)])

valid[(contlen+1):(contlen+nrowmiss)] <- 
plot.vb[plot.vb$Age %in% obsmiss[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] 

}

valid <- valid[valid>0]
#print(valid)

obsmiss$Pred <- valid


SSE.pred <- sum((obsmiss$Obs-obsmiss$Pred)^2)
SST.pred <- sum((obsmiss$Obs-mean(obsmiss$Obs))^2)
Rsq.pred <- 1-(SSE.pred/SST.pred)

mean.err.pred <- sqrt(mean((obsmiss$Obs-obsmiss$Pred)^2))


for (i in 1:nrow(obsmiss)) {
obsmiss$length.avg[i] = with(subset(data.df,Age==obsmiss$Age[i] & 
Cohort == levels(data.df$Cohort)[obsmiss$Cohort[i]]),mean(Length))
}




SSE.avg <- sum((obsmiss$Obs-obsmiss$length.avg)^2)
SST.avg <- sum((obsmiss$Obs-mean(obsmiss$Obs))^2)
Rsq.avg <- 1-(SSE.avg/SST.avg)

mean.err.avg <- sqrt(mean((obsmiss$Obs-obsmiss$length.avg)^2))
options(digits=2)

#size.label.x = 25
#size.text.x = 20
#size.point = 5
#size.label.y = 25
#size.text.y = 20
#size.legend.text = 15
#size.legend.title = 15
#unit.legend.h = 1.4
#unit.legend.w = 1.4


lb = paste("psi == ",0)

gvolpsi <- ggplot(subset(obsmiss), aes(x = Pred, y = Obs)) 	  
gvolpsi.0.modpred  <- gvolpsi + geom_point(pch = 16, size = size.point, col = col.points) +
coord_fixed() +
geom_abline(intercept=0, slope=1, linetype = 2, lwd=1.2) +
 #      ggtitle("mediantimesnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  scale_x_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  labs(y = "Observed length (mm)") +
           labs(x = "Predicted length (mm)") +
           #annotate("text", x = 150, y = 400, label = "a")
           annotate("text", x = 260, y = 200, 
          # label = "~psi~=~0.3",parse = T)
          label = lb,parse = TRUE)+
          annotate("text", x = 150, y = 300, label = "c", size = 6)
           
    gvolpsi <- ggplot(subset(obsmiss), aes(x = length.avg, y = Obs)) 	  
gvolpsi.0.avgpred  <- gvolpsi + geom_point(pch = 1, size = size.point,lwd =8) +
coord_fixed() +
geom_abline(intercept=0, slope=1, linetype = 2, lwd=1.2) +
 #      ggtitle("mediantimesnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,-9), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  scale_x_continuous(breaks=c(100,150,200,250,300),limits=c(120, 300)) +
	  labs(x = "Predicted length (mm)") +
	  labs(y = "Observed length (mm)") +
          annotate("text", x = 150, y = 300, label = "d", size = 6)#+
          # annotate("text", x = 150, y = 400, label = "b")
           



arrange_ggplot2(gvolpsi.1.modpred,gvolpsi.0.5.modpred,gvolpsi.0.modpred,
gvolpsi.0.avgpred,ncol = 2)

#800 500 on the macpro