 ## Function for arranging ggplots. use png(); arrange(p1, p2, ncol=1); dev.off() to save.
require(grid)
vp.layout <- function(x, y) viewport(layout.pos.row=x, layout.pos.col=y)
arrange_ggplot2 <- function(..., nrow=NULL, ncol=NULL, as.table=FALSE) {
	dots <- list(...)
	n <- length(dots)
	if(is.null(nrow) & is.null(ncol)) { nrow = floor(n/2) ; ncol = ceiling(n/nrow)}
	if(is.null(nrow)) { nrow = ceiling(n/ncol)}
	if(is.null(ncol)) { ncol = ceiling(n/nrow)}
        ## NOTE see n2mfrow in grDevices for possible alternative
grid.newpage()
pushViewport(viewport(layout=grid.layout(nrow,ncol) ) )
	ii.p <- 1
	for(ii.row in seq(1, nrow)){
	ii.table.row <- ii.row	
	if(as.table) {ii.table.row <- nrow - ii.table.row + 1}
		for(ii.col in seq(1, ncol)){
			ii.table <- ii.p
			if(ii.p > n) break
			print(dots[[ii.table]], vp=vp.layout(ii.table.row, ii.col))
			ii.p <- ii.p + 1
		}
	}
}


require(ggplot2)
require(grid)

VBsnovplot.f = function (beta,k0,log_sigma_v,v,log_sigma_u,u,t0,plpo,maxage=10) {
    age = seq(1,maxage,1)
    Length_age = rep(0,length(age))
    gamma = exp(beta*10 + exp(log_sigma_v)*v)
    k = exp(k0) * exp( exp(log_sigma_u)*u )
    Linf = gamma 
    
    for (ii in 1:length(age)) {
        
        Length_age[ii] = Linf*(1-exp(-k*(age[ii]-t0)))
        
    }
    if (plpo==0) {
        plot(Length_age ~ age, xlim = c(0,max(age)),ylim = c(0,max(Length_age)),pch=16)
    }
    
    else if (plpo==1) {
        points(Length_age ~ age,pch=15)
    }
    
    
    return(data.frame(Age=age,Length=Length_age))
}

VBsnov_psi = function (beta,k0,log_sigma_v,v,log_sigma_u,u,t0,plpo,psi.vb = 1,maxage=10) {
age = seq(1,maxage,1)
Length_age = rep(0,length(age))
gamma = exp(beta*10 + exp(log_sigma_v)*v)
k = exp(k0) * exp( exp(log_sigma_u)*u )
Linf = gamma 

for (ii in 1:length(age)) {

Length_age[ii] = Linf*(k^(psi.vb-1))*(1-exp(-k*(age[ii]-t0)))

}
if (plpo==0) {
plot(Length_age ~ age, xlim = c(0,max(age)),ylim = c(0,max(Length_age)),pch=16)
}

else if (plpo==1) {
points(Length_age ~ age,pch=15)
}
#print(Linf*(k^(psi.vb-1))
return(data.frame(Age=age,Length=Length_age))
}

   
    

size.label.x = 20
size.text.x = 15

size.label.y = 20
size.text.y = 15
size.legend.text = 15
size.legend.title = 15
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3
line.lwd = 2

#### plot 1200-600


# pardata = m_grow3_zak_Linfcohort_kcohort.par
   
    
data.df = subset(allstreams.zakojska.df, Cohort!="P" & Cohort!="C12")

data.df$Cohort = factor(data.df$Cohort)

dddata = subset(data.df,Cohort=="C99") 

fit.nls = nls(Length ~ Linf.nls*(1-exp(-k.nls*(Age-t0.nls))),data = dddata,
start = list(Linf.nls = 300, k.nls = 0.5, t0.nls = 0.3))

nls.predict.df = data.frame(Length = predict(fit.nls,newdata = data.frame(Age=1:14)),
Age = 1:14)

#the first cohort is the C00)

coh.num = which(levels(data.df$Cohort) == "C99")

pardata = m_grow3_zak_Linfcohort_kcohort.synth[[11]]$par # 11 has the psi = 1. i.e. standard vb

pardata_bestpsi = m_grow3_zak_Linfcohort_kcohort.synth[[((m_grow3_zak_Linfcohort_kcohort.psi)*10)+1]]$par


modplot_bestpsi =   VBsnov_psi((pardata_bestpsi$beta[1] + 
pardata_bestpsi$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata_bestpsi$beta_k0[1] + pardata_bestpsi$beta_k0[coh.num]*as.numeric(coh.num !=1)),
    pardata_bestpsi$log_sigma_v,0,
    pardata_bestpsi$log_sigma_u,0, 
    pardata_bestpsi$beta_t0,2,m_grow3_zak_Linfcohort_kcohort.psi,14)


modplot =   VBsnov_psi((pardata$beta[1] + pardata$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata$beta_k0[1] + pardata$beta_k0[coh.num]*as.numeric(coh.num !=1)),pardata$log_sigma_v,0,
    pardata$log_sigma_u,0, 
    pardata$beta_t0,2,1,14)
   
    ggcoh <- ggplot() 
    
  ggcohpredzak.firstcoh <- ggcoh  + 
  #geom_point(data = dddata, aes(x = Age, y = Length),size = 3, colour ="gray50") +
  geom_line(data = modplot,aes(x = Age, y = Length),col="black",lwd = line.lwd) +
  geom_line(data = nls.predict.df,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 2) +
  geom_line(data = modplot_bestpsi,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 4) +
  geom_line(data = dddata,aes(x = Age, y = Length,group = Mark),colour="gray50",lwd = 0.8,alpha = 0.2) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=seq(100,max(dddata$Length+30),100),limits=c(100,max(dddata$Length+30))) +
	  scale_x_continuous(breaks=seq(1,max(dddata$Age+1),1),limits=c(1, max(dddata$Age+1))) +
	   theme(plot.margin = unit(c(2,1,2,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y =" Length (mm)") +
           annotate("text",x = 1.2, y = 400, label = "a", size = 7)
           
           

####################### 
 
 
# pardata = m_grow3_zak_Linfcohort_kcohort.par
 
data.df = subset(allstreams.zakojska.df, Cohort!="P" & Cohort!="C12")

data.df$Cohort = factor(data.df$Cohort)

dddata = subset(data.df,Cohort=="C01")

fit.nls = nls(Length ~ Linf.nls*(1-exp(-k.nls*(Age-t0.nls))),data = dddata,
start = list(Linf.nls = 300, k.nls = 0.5, t0.nls = 0.3))

nls.predict.df = data.frame(Length = predict(fit.nls,newdata = data.frame(Age=1:14)),
Age = 1:14)

coh.num = which(levels(data.df$Cohort) == "C01")

pardata = m_grow3_zak_Linfcohort_kcohort.synth[[11]]$par # 11 has the psi = 1. i.e. standard vb

pardata_bestpsi = m_grow3_zak_Linfcohort_kcohort.synth[[((m_grow3_zak_Linfcohort_kcohort.psi)*10)+1]]$par


modplot_bestpsi =  VBsnov_psi((pardata_bestpsi$beta[1] + 
pardata_bestpsi$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata_bestpsi$beta_k0[1] + pardata_bestpsi$beta_k0[coh.num]*as.numeric(coh.num !=1)),
    pardata_bestpsi$log_sigma_v,0,
    pardata_bestpsi$log_sigma_u,0, 
    pardata_bestpsi$beta_t0,2,m_grow3_zak_Linfcohort_kcohort.psi,14)


modplot =   VBsnov_psi((pardata$beta[1] + pardata$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata$beta_k0[1] + pardata$beta_k0[coh.num]*as.numeric(coh.num !=1)),pardata$log_sigma_v,0,
    pardata$log_sigma_u,0, 
    pardata$beta_t0,2,1,14)

  
    ggcoh <- ggplot() 
    
  ggcohpredzak.seccoh<- ggcoh  + 
  #geom_point(data = dddata, aes(x = Age, y = Length),size = 3, colour ="gray50") +
  geom_line(data = modplot,aes(x = Age, y = Length),col="black",lwd = line.lwd) +
  geom_line(data = nls.predict.df,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 2) +
  geom_line(data = modplot_bestpsi,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 4) +
  geom_line(data = dddata,aes(x = Age, y = Length,group = Mark),colour="gray50",lwd = 0.8,alpha = 0.2) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=seq(100,max(dddata$Length+30),100),limits=c(100,max(dddata$Length+30))) +
	  scale_x_continuous(breaks=seq(1,max(dddata$Age+1),1),limits=c(1, max(dddata$Age+1))) +
	   theme(plot.margin = unit(c(2,1,2,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y ="")+
           annotate("text",x = 1.2, y = 400, label = "b", size = 7)
           
          # ggcohpred.seccoh
           
           
 ################################################################################          
 ################################################################################          
 ################################################################################          
 ################################################################################          
 ################################################################################          
 ################################################################################          
 ################################################################################          
 ################################################################################          


data.df = subset(allstreams.vol.df, Cohort!="C13", drop = T)

data.df$Cohort = factor(data.df$Cohort)

dddata = subset(data.df,Cohort=="C08") 

fit.nls = nls(Length ~ Linf.nls*(1-exp(-k.nls*(Age-t0.nls))),data = dddata,
start = list(Linf.nls = 300, k.nls = 0.5, t0.nls = 0.3))

nls.predict.df = data.frame(Length = predict(fit.nls,newdata = data.frame(Age=1:14)),
Age = 1:14)

#the first cohort is the C00)

coh.num = which(levels(data.df$Cohort) == "C08")

pardata = m_grow3_vol_Linfcohort_kcohort.synth[[11]]$par # 11 has the psi = 1. i.e. standard vb

pardata_bestpsi = m_grow3_vol_Linfcohort_kcohort.synth[[((m_grow3_vol_Linfcohort_kcohort.psi)*10)+1]]$par


modplot_bestpsi =   VBsnov_psi((pardata_bestpsi$beta[1] + 
pardata_bestpsi$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata_bestpsi$beta_k0[1] + pardata_bestpsi$beta_k0[coh.num]*as.numeric(coh.num !=1)),
    pardata_bestpsi$log_sigma_v,0,
    pardata_bestpsi$log_sigma_u,0, 
    pardata_bestpsi$beta_t0,2,m_grow3_vol_Linfcohort_kcohort.psi,14)


modplot =   VBsnov_psi((pardata$beta[1] + pardata$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata$beta_k0[1] + pardata$beta_k0[coh.num]*as.numeric(coh.num !=1)),pardata$log_sigma_v,0,
    pardata$log_sigma_u,0, 
    pardata$beta_t0,2,1,14)
   
    ggcoh <- ggplot() 
    
  ggcohpredvol.firstcoh <- ggcoh  + 
  #geom_point(data = dddata, aes(x = Age, y = Length),size = 3, colour ="gray50") +
  geom_line(data = modplot,aes(x = Age, y = Length),col="black",lwd = line.lwd) +
  geom_line(data = nls.predict.df,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 2) +
  geom_line(data = modplot_bestpsi,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 4) +
  geom_line(data = dddata,aes(x = Age, y = Length,group = Mark),colour="gray50",lwd = 0.8,alpha = 0.2) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=seq(100,max(dddata$Length+30),50),limits=c(100,max(dddata$Length+30))) +
	  scale_x_continuous(breaks=seq(1,max(dddata$Age+1),1),limits=c(1, max(dddata$Age+1))) +
	   theme(plot.margin = unit(c(2,1,2,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y =" Length (mm)")+
           annotate("text",x = 1.2, y = 250, label = "c", size = 7)
           
           

####################### 
 
 
# pardata = m_grow3_vol_Linfcohort_kcohort.par
 
data.df = subset(allstreams.vol.df, Cohort!="C13", drop = T)

data.df$Cohort = factor(data.df$Cohort)

dddata = subset(data.df,Cohort=="C07")

fit.nls = nls(Length ~ Linf.nls*(1-exp(-k.nls*(Age-t0.nls))),data = dddata,
start = list(Linf.nls = 300, k.nls = 0.5, t0.nls = 0.3))

nls.predict.df = data.frame(Length = predict(fit.nls,newdata = data.frame(Age=1:14)),
Age = 1:14)

coh.num = which(levels(data.df$Cohort) == "C07")

pardata = m_grow3_vol_Linfcohort_kcohort.synth[[11]]$par # 11 has the psi = 1. i.e. standard vb

pardata_bestpsi = m_grow3_vol_Linfcohort_kcohort.synth[[((m_grow3_vol_Linfcohort_kcohort.psi)*10)+1]]$par


modplot_bestpsi =  VBsnov_psi((pardata_bestpsi$beta[1] + 
pardata_bestpsi$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata_bestpsi$beta_k0[1] + pardata_bestpsi$beta_k0[coh.num]*as.numeric(coh.num !=1)),
    pardata_bestpsi$log_sigma_v,0,
    pardata_bestpsi$log_sigma_u,0, 
    pardata_bestpsi$beta_t0,2,m_grow3_vol_Linfcohort_kcohort.psi,14)


modplot =   VBsnov_psi((pardata$beta[1] + pardata$beta[coh.num] *as.numeric(coh.num!=1)),
    (pardata$beta_k0[1] + pardata$beta_k0[coh.num]*as.numeric(coh.num !=1)),pardata$log_sigma_v,0,
    pardata$log_sigma_u,0, 
    pardata$beta_t0,2,1,14)

  
    ggcoh <- ggplot() 
    
  ggcohpredvol.seccoh<- ggcoh  + 
  #geom_point(data = dddata, aes(x = Age, y = Length),size = 3, colour ="gray50") +
  geom_line(data = modplot,aes(x = Age, y = Length),col="black",lwd = line.lwd) +
  geom_line(data = nls.predict.df,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 2) +
  geom_line(data = modplot_bestpsi,aes(x = Age, y = Length),col="black",lwd = line.lwd,linetype = 4) +
  geom_line(data = dddata,aes(x = Age, y = Length,group = Mark),colour="gray50",lwd = 0.8,alpha = 0.2) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=seq(100,max(dddata$Length+30),50),limits=c(100,max(dddata$Length+30))) +
	  scale_x_continuous(breaks=seq(1,max(dddata$Age+1),1),limits=c(1, max(dddata$Age+1))) +
	   theme(plot.margin = unit(c(2,1,2,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y ="")+
           annotate("text",x = 1.2, y = 250, label = "d", size = 7)
           
         #  ggcohpred.seccoh
           
           
           
arrange_ggplot2(ggcohpredzak.firstcoh,ggcohpredzak.seccoh,
ggcohpredvol.firstcoh,ggcohpredvol.seccoh,ncol = 2)