### create and plot mock data set #######

mock.corr.f = function(psi.chain = c(0,0.1,1), cor.chain = c(-0.8,0.8,0), 
seed.sim = 5, n.tot.ind = 400, n.traj = 10,maxage = 7, log_sigma_u = -1.2, 
log_sigma_v = -1.2) { 


#mcorr = mock.corr.(psi.chain = c(0,0.5,1), cor.chain = c(-1,0.5,1), 
#seed.sim = 5, n.tot.ind = 400, n.traj = 15)

require(grid)
require(ggplot2)
library(MCMCglmm)

###maybe ration of standard deviations

## Function for arranging ggplots. use png(); arrange(p1, p2, ncol=1); dev.off() to save.
require(grid)
vp.layout <- function(x, y) viewport(layout.pos.row=x, layout.pos.col=y)
arrange_ggplot2 <- function(..., nrow=NULL, ncol=NULL, as.table=FALSE) {
	dots <- list(...)
	n <- length(dots)
	if(is.null(nrow) & is.null(ncol)) { nrow = floor(n/2) ; ncol = ceiling(n/nrow)}
	if(is.null(nrow)) { nrow = ceiling(n/ncol)}
	if(is.null(ncol)) { ncol = ceiling(n/nrow)}
        ## NOTE see n2mfrow in grDevices for possible alternative
grid.newpage()
pushViewport(viewport(layout=grid.layout(nrow,ncol) ) )
	ii.p <- 1
	for(ii.row in seq(1, nrow)){
	ii.table.row <- ii.row	
	if(as.table) {ii.table.row <- nrow - ii.table.row + 1}
		for(ii.col in seq(1, ncol)){
			ii.table <- ii.p
			if(ii.p > n) break
			print(dots[[ii.table]], vp=vp.layout(ii.table.row, ii.col))
			ii.p <- ii.p + 1
		}
	}
}

NormCorr.f <- function(n=100, rho = 0.4,sdfirst = 1) { 
     firstvect = rnorm(n,mean = 0, sd = sdfirst)
     secondvect = rnorm(n) 
     Z = cbind(firstvect, rho*firstvect+sqrt(1-rho^2)*secondvect) 
    return(Z) 
} 


size.label.x = 14
size.text.x = 9
line.lwd = 0.6
size.label.y = 14
size.text.y = 9
size.legend.text = 14
size.legend.title = 14
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3
col.line = "gray20"


VBsnov3_psi = function (beta,k0,log_sigma_v,v,log_sigma_u,u,t0,
log_sigma_w,w,plpo,psi.vb = 1,maxage=10) {

age = seq(1,maxage,1)
Length_age = rep(0,length(age))
gamma = exp(beta*10 + exp(log_sigma_v)*v)
k = exp(k0) * exp( exp(log_sigma_u)*u )
Linf = gamma 
t0 = t0 + exp(log_sigma_w)*w

for (ii in 1:length(age)) {

Length_age[ii] = Linf*(k^(psi.vb-1))*(1-exp(-k*(age[ii]-t0)))

}
if (plpo==0) {
plot(Length_age ~ age, xlim = c(0,max(age)),ylim = c(0,max(Length_age)),pch=16)
}

else if (plpo==1) {
points(Length_age ~ age,pch=15)
}

return(data.frame(Age=age,Length=Length_age))
}



#set.seed(seed.sim)

# list of ggplot2

gglist = list()

contgg = 1

#psi.vb <- 0


Linf.common = 300

n.tot.ind = n.tot.ind

mock.sets1 = data.frame(psi.1 = rep(0,n.tot.ind),
Linf.1 = rep(0,n.tot.ind), k.1 = rep(0,n.tot.ind), gamma.1 = rep(0,n.tot.ind))

mock.sets2 = data.frame(psi.2 = rep(0,n.tot.ind),
Linf.2 = rep(0,n.tot.ind), k.2 = rep(0,n.tot.ind), gamma.2 = rep(0,n.tot.ind))

mock.sets3 = data.frame(psi.3 = rep(0,n.tot.ind),
Linf.3 = rep(0,n.tot.ind), k.3 = rep(0,n.tot.ind), gamma.3 = rep(0,n.tot.ind))


mock.sets = cbind(mock.sets1,mock.sets2,mock.sets3)

cont.mock = 1

#psi.chain = c(0,0.5,1)

psi.chain = psi.chain
cor.chain = cor.chain

#print(cor.chain)

for (pcont in 1:length(psi.chain)) {


psi.vb <- psi.chain[pcont]

if (psi.chain[pcont]!=1) {
beta_k0 = -0.96 
beta = log(Linf.common * (exp(beta_k0))^(1-psi.vb))/10
beta_t0 = -0.32
log_sigma_v = log_sigma_v
log_sigma_u = log_sigma_u
log_sigma_w = -4
} else if (psi.chain[pcont] == 1) {
beta = log(Linf.common)/10
beta_k0 = -0.96 
beta_t0 = -0.32
log_sigma_u = log_sigma_u
log_sigma_v = log_sigma_v
log_sigma_w = -4
} #else if (psi.vb == 0.5) {
#beta_k0 = -0.82
#beta = log(Linf.common * (exp(beta_k0))^(1-psi.vb))/10
#beta_t0 = -0.32
#log_sigma_v = -1.5
#log_sigma_u = -1.5
#log_sigma_w = -4
#}



maxage = maxage


#cor.chain = cor.chain

for (j in 1:1) {
#generate a mock file of 200 individuals of age 1 to 10 using 3 random effects uncorrelated
####values are similar to those found for the population of Zakojska

n.tot.ind = n.tot.ind


mockrand = data.frame(Mark = (1:n.tot.ind),u = rep(0,n.tot.ind),w = rep(0,n.tot.ind),v=rep(0,n.tot.ind))

set.seed(seed.sim)
uv = NormCorr.f(n.tot.ind,rho = cor.chain[1])
mockrand$u = uv[,1]
mockrand$v = uv[,2]
mockrand$w = rnorm(n.tot.ind,0,0)

uv.real.cor = cor.test(mockrand$u,mockrand$v)
uv.real.cor = round(uv.real.cor$estimate,digits = 2)


mockdataset = data.frame(Mark = rep(mockrand$Mark,each=maxage),
Length = rep(0,n.tot.ind*(maxage)),
Age = rep(0,n.tot.ind*(maxage)))
contlen = 1
for (j in 1:n.tot.ind) {
plot.mock =VBsnov3_psi(beta,beta_k0,log_sigma_v,mockrand[j,"v"],log_sigma_u,
mockrand[j,"u"],beta_t0, log_sigma_w,mockrand[j,"w"], 2,psi.vb = psi.chain[pcont], 
maxage=maxage)

#mockdataset$Length[contlen: ((maxage+1)*i)] = plot.mock$Length
mockdataset$Length[(sum(mockdataset$Length>0)+1): ((maxage)*j)] = plot.mock$Length

#mockdataset$Age[contlen: ((maxage+1)*i)] = plot.mock$Age

mockdataset$Age[(sum(mockdataset$Age>0)+1): ((maxage)*j)] = plot.mock$Age


contlen = length(mockdataset$Length[mockdataset$Length>0])+1
}


}

k = exp(beta_k0) * exp( exp(log_sigma_u)*mockrand$u) 
## compute k (Eq. 7 in the ms)

Linf = exp(beta*10 + exp(log_sigma_v)*mockrand$v) * 
(k^(psi.chain[pcont]-1))

gamma = exp(beta*10 + exp(log_sigma_v)*mockrand$v)

print(paste("real cor = ", as.numeric(uv.real.cor), sep =""))
print(cor.test(k,Linf)$estimate)

mock.sets[,cont.mock] = psi.chain[pcont]
cont.mock = cont.mock + 1
mock.sets[,cont.mock] = Linf
cont.mock = cont.mock + 1
mock.sets[,cont.mock] = k
cont.mock = cont.mock + 1
mock.sets[,cont.mock] = gamma
cont.mock = cont.mock + 1 


#prior3.1 <- list(G = list(G1 = list(V = 1, nu = 0.002)), R = list(V = 1,
#nu = 0.002))
#mockrep <- MCMCglmm(Length ~ as.factor(Age), random = ~Mark,
#data = subset(mockdataset,Mark >1 & Mark<=200 & Age<=4),
#prior = prior3.1, verbose = FALSE, nitt=30000,burnin=5000) 
#plot(gatrep$Sol) 
#plot(gatrep$VCV)
#posterior.mode(mockrep$VCV)
#HPDinterval(mockrep$VCV)

#mod = mockrep
#mockrep.postmode.neg = 
#round(posterior.mode(mod$VCV)[1]/(posterior.mode(mod$VCV)[1]+posterior.mode(mod$VCV)[2]),digits = 4)
#mockreprep.hpd.neg = HPDinterval(mod$VCV[, 1]/rowSums(mod$VCV))

options(digits=2)


lb.neg <- paste("psi == ", psi.chain[pcont])

cor.lb.neg <- paste("r == ", uv.real.cor)

#print(psi.chain[pcont])
#print(lb.neg)

set.seed(seed.sim)

first.traj = round(runif(1,min = 1, max = n.tot.ind - (n.traj + 1)))

gmock <- ggplot(subset(mockdataset,Mark >first.traj & Mark<=(first.traj+n.traj)), 
aes(x = Age, y = Length)) 

#g <- ggplot(subset(uppidri.df,Mark!="NA" & Month == 9), aes(x = Age, y = Weight)) 

gmock.negcorr <- gmock + geom_line(aes(group = Mark),col="black",lwd = line.lwd) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=c(0,100,200,300,400,500),
      limits=c(0,500)) +
	  scale_x_continuous(breaks=seq(0,maxage,1),limits=c(0, (maxage + 0.5))) +
	   theme(
	   axis.title.x = element_text(size=size.label.x,vjust=0),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y ="Length") +
           #annotate("text", x = 1, y = 400, label = "a") +
           #annotate("text", x = 4, y = 50, label = 
           #bquote(.(mockrep.postmode.neg))) +
           annotate("text", x = 4, y = 70, label = 
           cor.lb.neg, parse = T) +
           #bquote("italic(r) = ",.(uv.real.cor))) + 
           annotate("text", x = 1, y = 450, label = lb.neg,parse = TRUE) 
            
           
gglist[[contgg]] = gmock.negcorr

contgg = contgg + 1


#plot.margin = unit(c(2,1,2,1), "cm"),
assign(paste("gmock.negcorr.",psi.chain[pcont],sep=""), gmock.negcorr)	  



for (i in 1:1) {
#generate a mock file of 200 individuals of age 1 to 10 using 3 random effects uncorrelated
####values are similar to those found for the population of Zakojska

n.tot.ind = n.tot.ind



mockrand = data.frame(Mark = (1:n.tot.ind),u = rep(0,n.tot.ind),w = rep(0,n.tot.ind),v=rep(0,n.tot.ind))

set.seed(seed.sim)
uv = NormCorr.f(n.tot.ind,rho = cor.chain[2])
mockrand$u = uv[,1]
mockrand$v = uv[,2]
mockrand$w = rnorm(n.tot.ind,0,0)

uv.real.cor = cor.test(mockrand$u,mockrand$v)
uv.real.cor = round(uv.real.cor$estimate,digits = 2)


mockdataset = data.frame(Mark = rep(mockrand$Mark,each=maxage),
Length = rep(0,n.tot.ind*(maxage)),
Age = rep(0,n.tot.ind*(maxage)))
contlen = 1
for (j in 1:n.tot.ind) {
plot.mock =VBsnov3_psi(beta,beta_k0,log_sigma_v,mockrand[j,"v"],log_sigma_u,
mockrand[j,"u"],beta_t0, log_sigma_w,mockrand[j,"w"], 2,psi.vb = psi.chain[pcont], maxage=maxage)

#mockdataset$Length[contlen: ((maxage+1)*i)] = plot.mock$Length
mockdataset$Length[(sum(mockdataset$Length>0)+1): ((maxage)*j)] = plot.mock$Length

#mockdataset$Age[contlen: ((maxage+1)*i)] = plot.mock$Age

mockdataset$Age[(sum(mockdataset$Age>0)+1): ((maxage)*j)] = plot.mock$Age


contlen = length(mockdataset$Length[mockdataset$Length>0])+1
}

}

k = exp(beta_k0) * exp( exp(log_sigma_u)*mockrand$u) 
## compute k (Eq. 7 in the ms)

Linf = exp(beta*10 + exp(log_sigma_v)*mockrand$v) * 
(k^(psi.mod[jj]-1))

print(uv.real.cor)
print(cor.test(k,Linf)$estimate)

#prior3.1 <- list(G = list(G1 = list(V = 1, nu = 0.002)), R = list(V = 1,
#nu = 0.002))
#mockrep <- MCMCglmm(Length ~ as.factor(Age), random = ~Mark, data = 
#subset(mockdataset,Mark >30 & Mark<=50),
#prior = prior3.1, verbose = FALSE, nitt=30000,burnin=5000) 
#plot(gatrep$Sol) 
#plot(gatrep$VCV)
#posterior.mode(mockrep$VCV)
#HPDinterval(mockrep$VCV)

#mod = mockrep
#mockrep.postmode.pos = 
#round(posterior.mode(mod$VCV)[1]/(posterior.mode(mod$VCV)[1]+posterior.mode(mod$VCV)[2]),digits = 2)
#mockreprep.hpd.pos = HPDinterval(mod$VCV[, 1]/rowSums(mod$VCV))



lb.pos <- paste("psi == ", psi.chain[pcont])
cor.lb.pos <- paste("r == ", uv.real.cor)


gmock <- ggplot(subset(mockdataset,Mark >first.traj & Mark<=(first.traj+n.traj)), 
aes(x = Age, y = Length)) 

#g <- ggplot(subset(uppidri.df,Mark!="NA" & Month == 9), aes(x = Age, y = Weight)) 

gmock.poscorr <- gmock + geom_line(aes(group = Mark),col="black",lwd = line.lwd) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=c(0,100,200,300,400,500),
      limits=c(0,500)) +
	  scale_x_continuous(breaks=seq(0,maxage,1),limits=c(0, (maxage+0.5))) +
	   theme(
	   axis.title.x = element_text(size=size.label.x,vjust=0),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y ="") +
           #annotate("text", x = 1, y = 400, label = "b") +
           #annotate("text", x = 4, y = 50, label = 
           #bquote(.(mockrep.postmode.pos))) +
           annotate("text", x = 4, y = 70, label = 
           cor.lb.pos, parse = T)
           #bquote(.(uv.real.cor))) #+ 
           #annotate("text", x = 1, y = 450, 
          
          #label = lb.pos,parse = TRUE)  

gglist[[contgg]] = gmock.poscorr

contgg = contgg + 1

#plot.margin = unit(c(2,1,2,0), "cm"),	   
assign(paste("gmock.poscorr.",psi.chain[pcont],sep=""), gmock.poscorr)	  
	
	


for (i in 1:1) {
#generate a mock file of 200 individuals of age 1 to 10 using 3 random effects uncorrelated
####values are similar to those found for the population of Zakojska

n.tot.ind = n.tot.ind


mockrand = data.frame(Mark = (1:n.tot.ind),u = rep(0,n.tot.ind),w = rep(0,n.tot.ind),v=rep(0,n.tot.ind))

set.seed(seed.sim)
uv = NormCorr.f(n.tot.ind,rho = cor.chain[3])
mockrand$u = uv[,1]
mockrand$v = uv[,2]
mockrand$w = rnorm(n.tot.ind,0,0)

uv.real.cor = cor.test(mockrand$u,mockrand$v)
uv.real.cor = round(uv.real.cor$estimate,digits = 2)


mockdataset = data.frame(Mark = rep(mockrand$Mark,each=maxage),
Length = rep(0,n.tot.ind*(maxage)),
Age = rep(0,n.tot.ind*(maxage)))
contlen = 1
for (j in 1:n.tot.ind) {
plot.mock =VBsnov3_psi(beta,beta_k0,log_sigma_v,mockrand[j,"v"],log_sigma_u,
mockrand[j,"u"],beta_t0, log_sigma_w,mockrand[j,"w"], 2,psi.vb = psi.chain[pcont],
 maxage=maxage)

#mockdataset$Length[contlen: ((maxage+1)*i)] = plot.mock$Length
mockdataset$Length[(sum(mockdataset$Length>0)+1): ((maxage)*j)] = plot.mock$Length

#mockdataset$Age[contlen: ((maxage+1)*i)] = plot.mock$Age

mockdataset$Age[(sum(mockdataset$Age>0)+1): ((maxage)*j)] = plot.mock$Age


contlen = length(mockdataset$Length[mockdataset$Length>0])+1
}

}

k = exp(beta_k0) * exp( exp(log_sigma_u)*mockrand$u) 
## compute k (Eq. 7 in the ms)

Linf = exp(beta*10 + exp(log_sigma_v)*mockrand$v) * 
(k^(psi.mod[jj]-1))

print(uv.real.cor)
print(cor.test(k,Linf)$estimate)


#prior3.1 <- list(G = list(G1 = list(V = 1, nu = 0.002)), R = list(V = 1,
#nu = 0.002))
#mockrep <- MCMCglmm(Length ~ as.factor(Age), random = ~Mark, data = 
#subset(mockdataset,Mark >30 & Mark<=50),
#prior = prior3.1, verbose = FALSE, nitt=30000,burnin=5000) 
#plot(gatrep$Sol) 
#plot(gatrep$VCV)
#posterior.mode(mockrep$VCV)
#HPDinterval(mockrep$VCV)

#mod = mockrep
#mockrep.postmode.null = 
#round(posterior.mode(mod$VCV)[1]/(posterior.mode(mod$VCV)[1]+posterior.mode(mod$VCV)[2]),digits = 2)
#mockreprep.hpd.null = HPDinterval(mod$VCV[, 1]/rowSums(mod$VCV))




lb.no <- paste("psi == ", psi.chain[pcont])
cor.lb.no <- paste("r == ", uv.real.cor)

gmock <- ggplot(subset(mockdataset,Mark >first.traj & Mark<=(first.traj+n.traj)), 
aes(x = Age, y = Length)) 

#g <- ggplot(subset(uppidri.df,Mark!="NA" & Month == 9), aes(x = Age, y = Weight)) 

gmock.nocorr <- gmock + geom_line(aes(group = Mark),col="black",lwd = line.lwd) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #     ggtitle("Simulated data") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=c(0,100,200,300,400,500),
      limits=c(0,500)) +
	  scale_x_continuous(breaks=seq(0,maxage,1),limits=c(0, (maxage + 0.5))) +
	   theme(
	   axis.title.x = element_text(size=size.label.x,vjust=0),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) +
           labs(x="Age", y ="") +
          # annotate("text", x = 1, y = 400, label = "c") +
          # annotate("text", x = 4, y = 50, label = 
          # bquote(.(mockrep.postmode.null))) +
           annotate("text", x = 4, y = 70, label = 
           cor.lb.no, parse = T)
           #bquote(.(uv.real.cor))) # +
          # annotate("text", x = 1, y = 450, 
          
          # label = lb.pos,parse = TRUE)
    
    gglist[[contgg]] = gmock.nocorr
    
    contgg = contgg + 1
           
   #plot.margin = unit(c(2,1,2,0), "cm"),        
  assign(paste("gmock.nocorr.",psi.chain[pcont],sep=""), gmock.nocorr)         
	  	
	  	
}	  	
	
#arrange_ggplot2(gmock.negcorr.0,gmock.poscorr.0,gmock.nocorr.0,
#				gmock.negcorr.0.5,gmock.poscorr.0.5,gmock.nocorr.0.5,
#				gmock.negcorr.1,gmock.poscorr.1,gmock.nocorr.1,ncol=3) 
				
gg.cont = 1:contgg				
				
arrange_ggplot2(gglist[[gg.cont[1]]],gglist[[gg.cont[2]]],gglist[[gg.cont[3]]],
gglist[[gg.cont[4]]],gglist[[gg.cont[5]]],gglist[[gg.cont[6]]],
gglist[[gg.cont[7]]], gglist[[gg.cont[8]]], gglist[[gg.cont[9]]], ncol = 3)				

return(mock.sets)
	
#print(mockrep.postmode.neg)
#print(mockrep.postmode.pos)
#print(mockrep.postmode.null)

}
	  
	## 1100 600 on macbook  
	  
	  
