
mock.recipr.corr.f = function(psi.vb.chain = 1, psi.chain = seq(0,1,0.1), seed.sim =c(7),
n.tot.ind = 50, log_sigma_u = 1.5, log_sigma_v = 1.5, thinning = 0) {


if(file.exists("m_grow13.par") == TRUE) {file.remove("m_grow13.par")}

#mock.recipr.corr.f(psi.vb1 = 1, psi.vb2 = 0, psi.vb3 = 0.5,seed.sim = c(1,2,3,4,5,6,7))


#mcorr.1.5 = mock.recipr.corr.f(psi.vb.chain = seq(0,1,0.1), seed.sim = c(55,56,57,58,59),log_sigma_u = -1.5, log_sigma_v = -1.5)
#mcorr.1 = mock.recipr.corr.f(psi.vb.chain = seq(0,1,0.1), seed.sim = c(55,56,57,58,59),log_sigma_u = -1, log_sigma_v = -1)
#mcorr.0.5 = mock.recipr.corr.f(psi.vb.chain = seq(0,1,0.1), seed.sim = c(55,56,57,58,59),log_sigma_u = -0.5, log_sigma_v = -0.5)

#mcorr.1b = mock.recipr.corr.f(psi.vb.chain = seq(0,1,0.1), seed.sim = c(55,56,57,58,59,
#60,61,62,63,64),log_sigma_u = -1, log_sigma_v = -1)



#rm(data)


#psi.vb1 can be equal to 1, 0.5 or 0. psi.vb2 and psi.vb3 can be whatever

##### load libraries #######
require(grid)
require(ggplot2)
require(MCMCglmm)
require(dplyr)
#############################


####### functions #####


######################################################################################
require(grid)
vp.layout <- function(x, y) viewport(layout.pos.row=x, layout.pos.col=y)
arrange_ggplot2 <- function(..., nrow=NULL, ncol=NULL, as.table=FALSE) {
	dots <- list(...)
	n <- length(dots)
	if(is.null(nrow) & is.null(ncol)) { nrow = floor(n/2) ; ncol = ceiling(n/nrow)}
	if(is.null(nrow)) { nrow = ceiling(n/ncol)}
	if(is.null(ncol)) { ncol = ceiling(n/nrow)}
        ## NOTE see n2mfrow in grDevices for possible alternative
grid.newpage()
pushViewport(viewport(layout=grid.layout(nrow,ncol) ) )
	ii.p <- 1
	for(ii.row in seq(1, nrow)){
	ii.table.row <- ii.row	
	if(as.table) {ii.table.row <- nrow - ii.table.row + 1}
		for(ii.col in seq(1, ncol)){
			ii.table <- ii.p
			if(ii.p > n) break
			print(dots[[ii.table]], vp=vp.layout(ii.table.row, ii.col))
			ii.p <- ii.p + 1
		}
	}
}

VBsnov3_psi = function (beta,k0,log_sigma_v,v,log_sigma_u,u,t0,
log_sigma_w,w,plpo,psi.vb = 1,maxage=10) {

age = seq(1,maxage,1)
Length_age = rep(0,length(age))
gamma = exp(beta*10 + exp(log_sigma_v)*v)
k = exp(k0) * exp( exp(log_sigma_u)*u )
Linf = gamma 
t0 = t0 + exp(log_sigma_w)*w

for (ii in 1:length(age)) {

Length_age[ii] = Linf*(k^(psi.vb-1))*(1-exp(-k*(age[ii]-t0)))

}
if (plpo==0) {
plot(Length_age ~ age, xlim = c(0,max(age)),ylim = c(0,max(Length_age)),pch=16)
}

else if (plpo==1) {
points(Length_age ~ age,pch=15)
}

return(data.frame(Age=age,Length=Length_age))
}

NormCorr.f <- function(n=100, rho = 0.4,sdfirst = 1) { 
     firstvect = rnorm(n,mean = 0, sd = sdfirst)
     secondvect = rnorm(n) 
     Z = cbind(firstvect, rho*firstvect+sqrt(1-rho^2)*secondvect) 
    return(Z) 
} 

######################################################################################

#### this routine is for estimating the reciprocal fitting of von bertalanffy growth curves
#when growth function with psi = 0, 0.5 or 1 are reciprocally fitted starting with positive
# negative, or zero correlation.



#nrow.psi.df = 6*length(seed.sim)

nrow.psi.df = length(psi.vb.chain)*length(psi.chain)*length(seed.sim)*3



psi.cor.df = data.frame("Orig.psi" = rep(0,nrow.psi.df),
"Orig.cor" = rep(0,nrow.psi.df),"Orig.cor.fact" = rep(0,nrow.psi.df), 
"Fit.psi" = rep(0,nrow.psi.df),
"Fit.cor" = rep(0,nrow.psi.df), "Fit.cil" = rep(0,nrow.psi.df),
 "Fit.ciu" = rep(0,nrow.psi.df), "Fit.grad" = rep(0,nrow.psi.df),
 "seed" = rep(0,nrow.psi.df), "MAE" = rep(0,nrow.psi.df))

contfordf = 1

for (vb.chain in 1:length(psi.vb.chain)) {


if (psi.vb.chain[vb.chain] != 1) {
beta_k0 = -0.96 
beta = log(Linf.common * (exp(beta_k0))^(1-psi.vb))/10
beta_t0 = -0.32
log_sigma_v = log_sigma_v
log_sigma_u = log_sigma_u
log_sigma_w = -4
} else if (psi.vb.chain[vb.chain] == 1) {
beta = log(Linf.common)/10
beta_k0 = -0.96 
beta_t0 = -0.32
log_sigma_v = log_sigma_v
log_sigma_u = log_sigma_u
log_sigma_w = -4
} #else if (psi.vb.chain[vb.chain] == 0.5) {
#beta_k0 = -0.82
#beta = log(Linf.common * (exp(beta_k0))^(1-psi.vb))/10
#beta_t0 = -0.32
#log_sigma_v = -1.5
#log_sigma_u = -1.5
#log_sigma_w = -4
#}


size.label.x = 14
size.text.x = 9
line.lwd = 0.6
size.label.y = 14
size.text.y = 9
size.legend.text = 14
size.legend.title = 14
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3
col.line = "gray20"






for (seed.series in 1:length(seed.sim)) {

set.seed(seed.sim[seed.series])


maxage = 10

rho.vett = c(-0.9,0.9,0)


for (rr in 1:length(rho.vett)) {
#generate a mock file of n.tot.ind individuals of age 1 to 10 using 3 random effects uncorrelated
####values are similar to those found for the population of Zakojska

n.tot.ind = n.tot.ind


mockrand = data.frame(Mark = (1:n.tot.ind),u = rep(0,n.tot.ind),
w = rep(0,n.tot.ind),v=rep(0,n.tot.ind))


uv = NormCorr.f(n.tot.ind,rho = rho.vett[rr] )
mockrand$u = uv[,1]
mockrand$v = uv[,2]
mockrand$w = rnorm(n.tot.ind,0,0)

uv.real.cor = cor.test(mockrand$u,mockrand$v)
#uv.real.cor = round(uv.real.cor$estimate,digits = 3)


mockdataset = data.frame(Mark = rep(mockrand$Mark,each=maxage),
Length = rep(0,n.tot.ind*(maxage)),
Age = rep(0,n.tot.ind*(maxage)))
contlen = 1

	for (j in 1:n.tot.ind) {
	plot.mock =VBsnov3_psi(beta,beta_k0,log_sigma_v,mockrand[j,"v"],log_sigma_u,
	mockrand[j,"u"],beta_t0, log_sigma_w,mockrand[j,"w"], 2,psi.vb = psi.vb.chain[vb.chain], maxage=maxage)

	#mockdataset$Length[contlen: ((maxage+1)*i)] = plot.mock$Length
	mockdataset$Length[(sum(mockdataset$Length>0)+1): ((maxage)*j)] = plot.mock$Length

	#mockdataset$Age[contlen: ((maxage+1)*i)] = plot.mock$Age

	mockdataset$Age[(sum(mockdataset$Age>0)+1): ((maxage)*j)] = plot.mock$Age


	contlen = length(mockdataset$Length[mockdataset$Length>0])+1
	}
	
	
if (thinning == 1) {
excluded = sample(1:nrow(mockdataset),(n.tot.ind*4))

mockdataset = mockdataset[-excluded,]
}



if (rho.vett[rr] < -0.2) {

	mockdataset.neg = mockdataset 
	uv.real.neg = uv.real.cor$estimate
	
	} else if (rho.vett[rr] > 0.2) {
	
	mockdataset.pos = mockdataset
	uv.real.pos = uv.real.cor$estimate
	
	
	} else { mockdataset.zero = mockdataset }
	
	uv.real.zero = uv.real.cor$estimate
	


}

#return(mockdataset.pos)

#prior3.1 <- list(G = list(G1 = list(V = 1, nu = 0.002)), R = list(V = 1,
#nu = 0.002))
#mockrep <- MCMCglmm(Length ~ as.factor(Age), random = ~Mark,
#data = subset(mockdataset,Mark >30 & Mark<=50),
#prior = prior3.1, verbose = FALSE, nitt=30000,burnin=5000) 
#plot(gatrep$Sol) 
#plot(gatrep$VCV)
#posterior.mode(mockrep$VCV)
#HPDinterval(mockrep$VCV)

#mod = mockrep
#mockrep.postmode.neg = 
#round(posterior.mode(mod$VCV)[1]/(posterior.mode(mod$VCV)[1]+posterior.mode(mod$VCV)[2]),digits = 2)
#mockreprep.hpd.neg = HPDinterval(mod$VCV[, 1]/rowSums(mod$VCV))


#psi.chain = c(psi.vb2, psi.vb3)

for (psi.cont in 1:length(psi.chain)) {

data_growth = mockdataset.neg
linf_var = "Const"
k_var = "Const"
psi_fixed <- psi.chain[psi.cont]

source("m_grow3_13psi_fixed.r", local =T)

if(file.exists("m_grow13.par") == TRUE) {

results.par = synth.list.psi_fixed.13$par  #get the parameters of the model

results.rep = synth.list.psi_fixed.13$rep

#print(results.rep)

results.grad.neg = synth.list.psi_fixed.13$grad

#if (contfordf>1) {

#if (identical(results.par$beta,results.par.prev$beta)==FALSE) { 



data = mockdataset.neg # data is as usual
# the dataset with no parental cohort and no cohort 2011

unique.mark = unique(data$Mark)  # all individuals


## some trivial code
nrow.mark = rep(0,length(unique.mark))


for (i in 1:length(unique.mark)) {

nrow.mark[i] = nrow(data[data$Mark == unique.mark[i],])

}	

k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u ) 
## compute k (Eq. 7 in the ms)

Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v) * 
(k^(psi.mod[jj]-1))

gamma.vb = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)


## compute Linf (Eq. 7 in the ms)

klinf.nrow = data.frame(Mark = unique.mark, k = k,linf = Linf, gamma.vb= gamma.vb, num.samp = nrow.mark)
# this dataset has for each individual mark,k,linf and how many times sampled


#with(klinf.nrow, plot(linf ~ k))

cor.mock.neg = with(klinf.nrow,cor.test(k,linf))

cor.mock.gamma.neg = with(klinf.nrow,cor.test(k,gamma.vb)) 


error = mockdataset.neg$Length - results.rep


MAE = mean(abs(error[,1]))


psi.cor.df$Orig.psi[contfordf] = psi.vb.chain[vb.chain]
psi.cor.df$Orig.cor[contfordf] = uv.real.neg
psi.cor.df$Orig.cor.fact[contfordf] = -1
psi.cor.df$Fit.psi[contfordf] = psi.chain[psi.cont]
#below it can be cor.mock.neg (Linf) or cor.mock.gamma.neg (with gamma)
psi.cor.df$Fit.cor[contfordf] = cor.mock.gamma.neg$estimate
psi.cor.df$Fit.cil[contfordf] = cor.mock.gamma.neg$conf.int[1]
psi.cor.df$Fit.ciu[contfordf] = cor.mock.gamma.neg$conf.int[2]
psi.cor.df$Fit.grad[contfordf] = results.grad.neg
psi.cor.df$seed[contfordf] = seed.sim[seed.series]
psi.cor.df$MAE[contfordf] = MAE

}else {

psi.cor.df$Orig.psi[contfordf] = psi.vb.chain[vb.chain]
psi.cor.df$Orig.cor[contfordf] = uv.real.neg
psi.cor.df$Orig.cor.fact[contfordf] = -1
psi.cor.df$Fit.psi[contfordf] = psi.chain[psi.cont]
#below it can be cor.mock.neg (Linf) or cor.mock.gamma.neg (with gamma)
psi.cor.df$Fit.cor[contfordf] = NA
psi.cor.df$Fit.cil[contfordf] = NA
psi.cor.df$Fit.ciu[contfordf] = NA
psi.cor.df$Fit.grad[contfordf] = NA
psi.cor.df$seed[contfordf] = seed.sim[seed.series]
psi.cor.df$MAE[contfordf] = NA

}

if(file.exists("m_grow13.par") == TRUE) {file.remove("m_grow13.par")}

contfordf = contfordf + 1 

results.par.prev = synth.list.psi_fixed.13$par

#print(cor.mock.neg)


#######


data_growth = mockdataset.pos
linf_var = "Const"
k_var = "Const"
psi_fixed <- psi.chain[psi.cont]

source("m_grow3_13psi_fixed.r", local =T)

if(file.exists("m_grow13.par") == TRUE) {

results.par = synth.list.psi_fixed.13$par

results.rep = synth.list.psi_fixed.13$rep

results.grad.pos = synth.list.psi_fixed.13$grad  #get the parameters of the model

#if (identical(results.par$beta,results.par.prev$beta)==FALSE) {


data = mockdataset.pos # data is as usual
# the dataset with no parental cohort and no cohort 2011

unique.mark = unique(data$Mark)  # all individuals


## some trivial code
nrow.mark = rep(0,length(unique.mark))


for (i in 1:length(unique.mark)) {

nrow.mark[i] = nrow(data[data$Mark == unique.mark[i],])

}	

k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u ) 
## compute k (Eq. 7 in the ms)

Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v) * 
(k^(psi.mod[jj]-1))

gamma.vb = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)

## compute Linf (Eq. 7 in the ms)

klinf.nrow = data.frame(Mark = unique.mark, k = k,linf = Linf, gamma.vb = gamma.vb, num.samp = nrow.mark)
# this dataset has for each individual mark,k,linf and how many times sampled


#with(klinf.nrow, plot(linf ~ k))

cor.mock.pos = with(klinf.nrow,cor.test(k,linf))

cor.mock.gamma.pos = with(klinf.nrow,cor.test(k,gamma.vb))

error = mockdataset.pos$Length - results.rep
MAE = mean(abs(error[,1]))


#print(psi.vb1)

#print(psi.cor.df$Orig.psi[contfordf])

psi.cor.df$Orig.psi[contfordf] = psi.vb.chain[vb.chain]
psi.cor.df$Orig.cor[contfordf] = uv.real.pos
psi.cor.df$Orig.cor.fact[contfordf] = 1
psi.cor.df$Fit.psi[contfordf] = psi.chain[psi.cont]
#below it can be cor.mock.neg (Linf) or cor.mock.gamma.neg (with gamma)
psi.cor.df$Fit.cor[contfordf] = cor.mock.gamma.pos$estimate
psi.cor.df$Fit.cil[contfordf] = cor.mock.gamma.pos$conf.int[1]
psi.cor.df$Fit.ciu[contfordf] = cor.mock.gamma.pos$conf.int[2]
psi.cor.df$Fit.grad[contfordf] = results.grad.pos
psi.cor.df$seed[contfordf] = seed.sim[seed.series]
psi.cor.df$MAE[contfordf] = MAE

} else {

psi.cor.df$Orig.psi[contfordf] = psi.vb.chain[vb.chain]
psi.cor.df$Orig.cor[contfordf] = uv.real.pos
psi.cor.df$Orig.cor.fact[contfordf] = 1
psi.cor.df$Fit.psi[contfordf] = psi.chain[psi.cont]
#below it can be cor.mock.neg (Linf) or cor.mock.gamma.neg (with gamma)
psi.cor.df$Fit.cor[contfordf] = NA
psi.cor.df$Fit.cil[contfordf] = NA
psi.cor.df$Fit.ciu[contfordf] = NA
psi.cor.df$Fit.grad[contfordf] = NA
psi.cor.df$seed[contfordf] = seed.sim[seed.series]
psi.cor.df$MAE[contfordf] = NA

}

if(file.exists("m_grow13.par") == TRUE) {file.remove("m_grow13.par")}

contfordf = contfordf + 1

results.par.prev = synth.list.psi_fixed.13$par

#print(cor.mock.pos)

##########

data_growth = mockdataset.zero
linf_var = "Const"
k_var = "Const"
psi_fixed <- psi.chain[psi.cont]

source("m_grow3_13psi_fixed.r", local =T)

if(file.exists("m_grow13.par") == TRUE) {

results.par = synth.list.psi_fixed.13$par  #get the parameters of the model

results.rep = synth.list.psi_fixed.13$rep

results.grad.zero = synth.list.psi_fixed.13$grad

#if (identical(results.par$beta,results.par.prev$beta)==FALSE) {



data = mockdataset.zero # data is as usual
# the dataset with no parental cohort and no cohort 2011

unique.mark = unique(data$Mark)  # all individuals


## some trivial code
nrow.mark = rep(0,length(unique.mark))


for (i in 1:length(unique.mark)) {

nrow.mark[i] = nrow(data[data$Mark == unique.mark[i],])

}	

k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u ) 
## compute k (Eq. 7 in the ms)

Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v) * 
(k^(psi.mod[jj]-1))

gamma.vb = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)

## compute Linf (Eq. 7 in the ms)

klinf.nrow = data.frame(Mark = unique.mark, k = k,linf = Linf, 
gamma.vb = gamma.vb, num.samp = nrow.mark)
# this dataset has for each individual mark,k,linf and how many times sampled


#with(klinf.nrow, plot(linf ~ k))

cor.mock.zero = with(klinf.nrow,cor.test(k,linf))

cor.mock.gamma.zero = with(klinf.nrow,cor.test(k,gamma.vb))

error = mockdataset.zero$Length - results.rep
MAE = mean(abs(error[,1]))


psi.cor.df$Orig.psi[contfordf] = psi.vb.chain[vb.chain]
psi.cor.df$Orig.cor[contfordf] = uv.real.zero
psi.cor.df$Orig.cor.fact[contfordf] = 0
psi.cor.df$Fit.psi[contfordf] = psi.chain[psi.cont]
#below it can be cor.mock.neg (Linf) or cor.mock.gamma.neg (with gamma)
psi.cor.df$Fit.cor[contfordf] = cor.mock.gamma.zero$estimate
psi.cor.df$Fit.cil[contfordf] = cor.mock.gamma.zero$conf.int[1]
psi.cor.df$Fit.ciu[contfordf] = cor.mock.gamma.zero$conf.int[2]
psi.cor.df$Fit.grad[contfordf] = results.grad.zero
psi.cor.df$seed[contfordf] = seed.sim[seed.series]
psi.cor.df$MAE[contfordf] = MAE

} else{

psi.cor.df$Orig.psi[contfordf] = psi.vb.chain[vb.chain]
psi.cor.df$Orig.cor[contfordf] = uv.real.zero
psi.cor.df$Orig.cor.fact[contfordf] = 0
psi.cor.df$Fit.psi[contfordf] = psi.chain[psi.cont]
#below it can be cor.mock.neg (Linf) or cor.mock.gamma.neg (with gamma)
psi.cor.df$Fit.cor[contfordf] = NA
psi.cor.df$Fit.cil[contfordf] = NA
psi.cor.df$Fit.ciu[contfordf] = NA
psi.cor.df$Fit.grad[contfordf] = NA
psi.cor.df$seed[contfordf] = seed.sim[seed.series]
psi.cor.df$MAE[contfordf] = NA
}

if(file.exists("m_grow13.par") == TRUE) {file.remove("m_grow13.par")}

contfordf = contfordf + 1

results.par.prev = synth.list.psi_fixed.13$par

}

}

}

#print(cor.mock.neg)
#print(cor.mock.pos)
#print(cor.mock.zero)

#print(results.grad.neg)
#print(results.grad.pos)
#print(results.grad.zero)


psi.cor.df = arrange(psi.cor.df, Fit.psi,Orig.cor)

return(psi.cor.df)




#cor.psi.zak.df$cor[jj] = cor.k.linf.zak$estimate
#cor.psi.zak.df$ci.low[jj] = cor.k.linf.zak$conf.int[1]
#cor.psi.zak.df$ci.up[jj] = cor.k.linf.zak$conf.int[2]
#cor.psi.zak.df$p.val[jj] = cor.k.linf.zak$p.value

#cor.k.linf.zak.only1 = with(subset(klinf.nrow,num.samp == 1),cor.test(k,linf))

#cor.k.linf.zak.over2 =  with(subset(klinf.nrow,num.samp > 2),cor.test(k,linf))


}

#######################################
	  
	  
	