source("ADMButils.s")




#### ZAKOJSKA

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Const"
k_var = "Const"
source("m_grow3_zak0_noP18psi.r")  #model with no predictors
#system("./m_grow3 -est")  ##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak0_noP181.synth = synth.list.18
m_grow3_zak0_noP181.psi = best.psi

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Const"
k_var = "Cohort"
source("m_grow3_zak0_noP18psi.r") #model with cohort as predictor for k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_kcohort18.synth = synth.list.18
m_grow3_zak_kcohort18.psi = best.psi

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Cohort"
k_var = "Const"
source("m_grow3_zak0_noP18psi.r")#model with cohort as predictor for Linf
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort18.synth = synth.list.18
m_grow3_zak_Linfcohort18.psi = best.psi

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Cohort"
k_var = "Cohort"
source("m_grow3_zak0_noP18psi.r") #model with cohort as predictor for Linf and k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort_kcohort18.synth = synth.list.18
m_grow3_zak_Linfcohort_kcohort18.psi = best.psi



#### Upper Volaja ####


library(dplyr)
allstreams.vol.df = read.table("vol2018.txt",header = T)
allstreams.vol.df = filter(allstreams.vol.df,Month == 6, Mark!="NA")

data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Const"
k_var = "Const"
source("m_grow3_zak0_noP18psi.r")  #model with no predictors
#system("./m_grow3 -est")  ##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol0_noP18.synth = synth.list.18
m_grow3_vol0_noP18.psi = best.psi


data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Const"
k_var = "Cohort"
source("m_grow3_zak0_noP18psi.r") #model with cohort as predictor for k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol_kcohort18.synth = synth.list.18
m_grow3_vol_kcohort18.psi = best.psi

data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Cohort"
k_var = "Const"
source("m_grow3_zak0_noP18psi.r")#model with cohort as predictor for Linf
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol_Linfcohort18.synth = synth.list.18
m_grow3_vol_Linfcohort18.psi = best.psi

data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Cohort"
k_var = "Cohort"
source("m_grow3_zak0_noP18psi.r") #model with cohort as predictor for Linf and k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol_Linfcohort_kcohort18.synth = synth.list.18
m_grow3_vol_Linfcohort_kcohort18.psi = best.psi

save.image("allstreams2013psi.June.RData")

