source("ADMButils.s")


#### ZAKOJSKA

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Const"  # input for creating model matrix (constant in this case). Model matrix is created when sourcing m_grow3_zak0_noP13psi.r 
k_var = "Const" # input for creating model matrix (constant in this case). Model matrix is created when sourcing m_grow3_zak0_noP13psi.r 
source("m_grow3_zak0_noP13psi.r")  #model with no predictors
#system("./m_grow3 -est")  ##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak0_noP.synth = synth.list.13
m_grow3_zak0_noP.psi = best.psi

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Const"
k_var = "Cohort"
source("m_grow3_zak0_noP13psi.r") #model with cohort as predictor for k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_kcohort.synth = synth.list.13
m_grow3_zak_kcohort.psi = best.psi

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Cohort"
k_var = "Const"
source("m_grow3_zak0_noP13psi.r")#model with cohort as predictor for Linf
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort.synth = synth.list.13
m_grow3_zak_Linfcohort.psi = best.psi

data_growth = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="P")
data_growth$Cohort = factor(data_growth$Cohort)
linf_var = "Cohort"
k_var = "Cohort"
source("m_grow3_zak0_noP13psi.r") #model with cohort as predictor for Linf and k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort_kcohort.synth = synth.list.13
m_grow3_zak_Linfcohort_kcohort.psi = best.psi


#### Upper Volaja ####


library(dplyr)
allstreams.vol.df = read.table("vol2013.txt",header = T)
allstreams.vol.df = filter(allstreams.vol.df,Month == 6, Mark!="NA")

data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Const"
k_var = "Const"
source("m_grow3_zak0_noP13psi.r")  #model with no predictors
#system("./m_grow3 -est")  ##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol0_noP.synth = synth.list.13
m_grow3_vol0_noP.psi = best.psi


data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Const"
k_var = "Cohort"
source("m_grow3_zak0_noP13psi.r") #model with cohort as predictor for k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol_kcohort.synth = synth.list.13
m_grow3_vol_kcohort.psi = best.psi

data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Cohort"
k_var = "Const"
source("m_grow3_zak0_noP13psi.r")#model with cohort as predictor for Linf
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol_Linfcohort.synth = synth.list.13
m_grow3_vol_Linfcohort.psi = best.psi

data_growth = subset(allstreams.vol.df, Cohort!="C12", drop = T)
data_growth = data.frame(lapply(data_growth, function(x) if (is.factor(x)){ factor(x)} else {x}))
linf_var = "Cohort"
k_var = "Cohort"
source("m_grow3_zak0_noP13psi.r") #model with cohort as predictor for Linf and k
#system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_vol_Linfcohort_kcohort.synth = synth.list.13
m_grow3_vol_Linfcohort_kcohort.psi = best.psi